<?php
defined('_JEXEC') or die('Restricted access');

class ElementJBRelatedAuto extends Element {

	protected $_related_items;
	
	public function hasValue($params = array()) {
		$items = $this->_getRelatedAuto();
		return !empty($items);
	}
	
	function edit() {
		return false;
	}
	
	private function _getRelatedAuto() {
		if ($this->_related_items == null) {
			$db 	=& JFactory::getDBO();
			$user 	=& JFactory::getUser();
			$date 	=& JFactory::getDate();
			
			$id 		= JRequest::getVar('item_id');
			$nullDate	= $db->getNullDate();
			$now  		= $date->toMySQL();
			
			$document = & JFactory::getDocument();
			$keywords = $document->getMetaData('keywords');
			
			$tmp_likes = explode(',', $keywords);
			$tags = YTable::getInstance('tag')->getItemTags($id);
			
			$tmp_likes = array_merge($tmp_likes, $tags);
			
			$likes = array();
			foreach($tmp_likes as $like) {
				$like = mb_strToLower(trim($like));
				if (strlen($like) > 2) {
					$likes[$like] = $like;
				}
			}
			
			if (count($likes) == 0) return false;
			
			$sql = 'SELECT
					(innerFulltext.rel * COUNT(tag.item_id)) AS weight,
					item.id,
					innerFulltext.rel as fullRel,
					COUNT(tag.item_id) AS tagRel
				FROM
					jos_zoo_tag AS tag
				 	INNER JOIN jos_zoo_item AS item ON item.id = tag.item_id
					INNER JOIN (
						SELECT
							items.id as id,
							(
								IF(items.name LIKE "%' .implode('%", 2, 0) + IF(items.name LIKE "%', $likes). '%", 2, 0) +	
								IF(items.elements LIKE "%' .implode('%", 1, 0) + IF(items.elements LIKE "%', $likes). '%", 1, 0)
							) AS rel
						FROM
							jos_zoo_item AS items
					) innerFulltext ON innerFulltext.id = tag.item_id 
				WHERE
					tag.name in ("' .implode('", "', $likes). '") AND
					item.id <> "' .$id. '"
				GROUP BY
					tag.item_id
				ORDER BY
					weight DESC,
					tagRel DESC,
					fullRel DESC,
					RAND()
				LIMIT 5';
			
			$db->setQuery($sql);
			$result = $db->loadAssocList();
	
			$ids = array();
			foreach($result as $item) {
				if ($item['weight'] > 2 && !isset($GLOBALS['exclude_items_auto'][$item['id']])) {
					$ids[] = $item['id'];
				}
			}
			
			$itemCurrent = $this->getItem();
			
			$options = array();
			$options['conditions'] = ZOO_TABLE_ITEM.'.id IN ("' .implode('", "', $ids). '")';
			$items = YTable::getInstance('item')->findAll($itemCurrent->application_id, true, null, $options);
            return $items;
		}
	}
	
	
	public function render($params = array()) {
		$items = $this->_getRelatedAuto();
		
		if (count($items) > 0) {
			foreach($items as $item) {
				$url	  = RouteHelper::getItemRoute($item);
				$output[] = '<a href="'.JRoute::_($url).'" title="'.$item->name.'">'.$item->name.'</a>';
			}
			return ElementHelper::applySeparators($params['separated_by'], $output);
		}
	}
}
